#include "../../include/all.h"
#include "../common.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main(int argc, char *argv[]) {
  int        ret = EXIT_FAILURE;
  lm_entry_t entry;
  lm_ctx_t   ctx;

  lm_entry_init(&entry);

  if (argc != 2) {
    printf("usage: %s <package name>\n", argv[0]);
    return ret;
  }

  if (!lm_ctx_new(&ctx, ROOT_DIR, TEMP_DIR, DATA_DIR)) {
    printf("failed to init the ctx: %s (%d)\n", lm_strerror(), lm_error());
    goto end;
  }

  if (!lm_ctx_database_find(&ctx, &entry, argv[1], NULL)) {
    printf("failed to find package: %s (%d)\n", lm_strerror(), lm_error());
    goto end;
  }

  if (!lm_ctx_removeable(&ctx, &entry)) {
    printf("cannot remove package: %s (%d)\n", lm_strerror(), lm_error());
    goto end;
  }

  printf("removing package: %s (%s)...\n", entry.name, entry.version);

  if (!lm_ctx_remove(&ctx, &entry, NULL, NULL)) {
    printf("failed to remove package: %s (%d)\n", lm_strerror(), lm_error());
    goto end;
  }

  ret = EXIT_SUCCESS;

end:
  lm_entry_free(&entry);
  lm_ctx_free(&ctx);
  return ret;
}
