#include "../../include/package.h"
#include "../../include/error.h"
#include "../../include/ctx.h"

#include <strings.h>

lm_ctx_list_t *lm_ctx_list(lm_ctx_t *ctx, lm_ctx_list_t *list){
  if(NULL == ctx || NULL == list){
    lm_error_set(LM_ERR_ArgNULL);
    return NULL;
  }

  list->pool = ctx->pools;
  list->head = ctx->pools;
  list->pkg  = NULL;
  list->count = 0;

  while(NULL != list->pool){
    list->pkg = list->pool->pkg;
    while(NULL != list->pkg){
      list->count++;
      list->pkg = list->pkg->next;
    }
    list->pool = list->pool->next;
  }

  list->pool = NULL;
  list->pkg  = NULL;
  return list;
}

lm_pkg_t *lm_ctx_list_next(lm_ctx_list_t *list){
  if(NULL == list){
    lm_error_set(LM_ERR_ArgNULL);
    return NULL;
  }

  if(NULL == list->pool || NULL == list->pkg){
    if((list->pool = list->head) != NULL)
      list->pkg = list->pool->pkg;
    return list->pkg;
  }

  if((list->pkg = list->pkg->next) && NULL == list->pkg){
    if((list->pool = list->pool->next) != NULL)
      list->pkg = list->pool->pkg;
    return list->pkg;
  }

  return list->pkg;
}

void lm_ctx_list_free(lm_ctx_list_t *list){
  if(NULL == list){
    lm_error_set(LM_ERR_ArgNULL);
    return;
  }

  bzero(list, sizeof(lm_ctx_list_t));
}
