#include "../../include/package.h"
#include "../../include/error.h"
#include "../../include/util.h"

#include <stdlib.h>
#include <string.h>

bool lm_package_path_set_archive(lm_pkg_t *pkg, char *archive_path){
  free(pkg->archive);
  pkg->archive = NULL;

  if(NULL == archive_path)
    return true;

  if(is_dir(archive_path))
    return false;

  pkg->archive = strdup(archive_path);
  return true;
}

bool lm_package_path_set_signature(lm_pkg_t *pkg, char *signature_path){
  free(pkg->signature);
  pkg->signature = NULL;

  if(NULL == signature_path)
    return true;

  if(is_dir(signature_path))
    return false;

  pkg->signature = strdup(signature_path);
  return true;
}

bool lm_package_path_is_empty(lm_pkg_t *pkg){
  return NULL == pkg->signature ||
         NULL == pkg->archive;
}

bool lm_package_path_copy(lm_pkg_t *dst, lm_pkg_t *src){
  if(NULL == dst || NULL == src){
    lm_error_set(LM_ERR_ArgNULL);
    return false;
  }

  if(NULL != src->archive)
    dst->archive = strdup(src->archive);

  if(NULL != src->signature)
    dst->signature = strdup(src->signature);

  return true;
}
