#include "../../include/error.h"
#include "../../include/pool.h"
#include "../../include/util.h"

#include <stdlib.h>
#include <string.h>

bool lm_pool_path_set_dir(lm_pool_t *pool, char *dir){
  free(pool->dir);
  free(pool->info_file);
  free(pool->list_file);

  pool->dir = NULL;
  pool->info_file = NULL;
  pool->list_file = NULL;

  if(NULL == dir)
    return true;

  if(exists(dir, NULL) && (is_file(dir) || !can_read(dir))){
    lm_error_set(LM_ERR_PoolBadDir);
    return false;
  }

  pool->dir = strdup(dir);
  pool->info_file = join_alloc(dir, "INFO"); 
  pool->list_file = join_alloc(dir, "LIST"); 
  
  if(exists(pool->info_file, NULL) && (!is_file(pool->info_file) || !can_read(pool->info_file))){
    lm_error_set(LM_ERR_PoolBadPaths);
    return false;
  }
  
  if(exists(pool->list_file, NULL) && (!is_file(pool->list_file) || !can_read(pool->list_file))){
    lm_error_set(LM_ERR_PoolBadPaths);
    return false;
  }
 
  return true;
}

bool lm_pool_path_is_empty(lm_pool_t *pool){
  return NULL == pool->info_file ||
         NULL == pool->list_file ||
         NULL == pool->dir;
}
